You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.
 
 
 
 

367 lines
17 KiB

  1. #!/bin/sh
  2. command -V gpg >/dev/null 2>&1 && GPG="gpg" || GPG="gpg2"
  3. [ -z ${PASSWORD_STORE_DIR+x} ] && PASSWORD_STORE_DIR="$HOME/.password-store"
  4. [ -r "$PASSWORD_STORE_DIR/.gpg-id" ] &&
  5. "$GPG" --list-secret-keys $(cat "$PASSWORD_STORE_DIR/.gpg-id") >/dev/null 2>&1 || {
  6. printf "\`pass\` must be installed and initialized to encrypt passwords.\\nBe sure it is installed and run \`pass init <yourgpgemail>\`.\\nIf you don't have a GPG public private key pair, run \`%s --full-gen-key\` first.\\n" "$GPG"
  7. exit
  8. }
  9. ! command -v mbsync >/dev/null && printf "\`mbsync (isync package)\` must be installed to run mutt-wizard.\\n" && exit
  10. prefix="/usr/local"
  11. muttdir="$HOME/.config/mutt" # Main mutt config location
  12. accdir="$muttdir/accounts" # Directory for account settings
  13. maildir="$HOME/.local/share/mail" # Location of mail storage
  14. namere="^[a-z_][a-z0-9_-]*$" # Regex to ensure viable username
  15. emailre=".\+@.\+\\..\+" # Regex to confirm valid email address
  16. muttshare="$prefix/share/mutt-wizard"
  17. mbsyncrc="$HOME/.mbsyncrc"
  18. mwconfig="$muttshare/mutt-wizard.muttrc"
  19. cachedir="$HOME/.cache/mutt-wizard"
  20. muttrc="$muttdir/muttrc"
  21. msmtprc="$HOME/.config/msmtp/config"
  22. ssltype="IMAPS" # This is later changed to `None` later in the script if using Protonmail
  23. for x in "/etc/ssl/certs/ca-certificates.crt" "/etc/pki/tls/certs/ca-bundle.crt" "/etc/ssl/ca-bundle.pem" "/etc/pki/tls/cacert.pem" "/etc/pki/ca-trust/extracted/pem/tls-ca-bundle.pem" "/etc/ssl/cert.pem" "/usr/local/share/ca-certificates/"
  24. do
  25. [ -f "$x" ] && sslcert="$x" && break
  26. done || { echo "CA Certificate not found. Please install one or link it to /etc/ssl/certs/ca-certificates.crt" && exit 1 ;}
  27. getaccounts() { accounts="$(find "$accdir" -type f | grep -o "[0-9]-.*.muttrc" | sed "s/-/: /;s/\..*//" | sort -n)" ;}
  28. list() { getaccounts && [ -n "$accounts" ] && echo "$accounts" ;}
  29. getprofiles() { \
  30. unset msmtp_header msmtp_profile mutt_profile mbsync_profile
  31. printf "Creating profiles for \`%s\`..." "$title"
  32. msmtp_header="defaults
  33. auth on
  34. tls on
  35. tls_trust_file $sslcert
  36. logfile ~/.config/msmtp/msmtp.log
  37. "
  38. msmtp_profile="account $title
  39. host $smtp
  40. port $sport
  41. from $fulladdr
  42. user $login
  43. passwordeval \"pass mutt-wizard-$title\"
  44. $starttlsoff
  45. "
  46. mbsync_profile="IMAPStore $title-remote
  47. Host $imap
  48. Port $iport
  49. User $login
  50. PassCmd \"pass mutt-wizard-$title\"
  51. AuthMechs LOGIN
  52. SSLType $ssltype
  53. CertificateFile $sslcert
  54. MaildirStore $title-local
  55. Subfolders Verbatim
  56. Path ~/.local/share/mail/$title/
  57. Inbox ~/.local/share/mail/$title/INBOX
  58. Flatten .
  59. Channel $title
  60. Expunge Both
  61. Master :$title-remote:
  62. Slave :$title-local:
  63. Patterns * !\"[Gmail]/All Mail\"
  64. Create Both
  65. SyncState *
  66. MaxMessages $maxmes
  67. ExpireUnread no
  68. # End profile
  69. "
  70. if [ "$accounttype" = "offline" ]; then
  71. mutt_profile="# vim: filetype=neomuttrc
  72. # muttrc file for account $title
  73. set realname = \"$realname\"
  74. set from = \"$fulladdr\"
  75. set sendmail = \"msmtp -a $title\"
  76. alias me $realname <$fulladdr>
  77. set folder = \"$maildir/$title\"
  78. set header_cache = $cachedir/$title/headers
  79. set message_cachedir = $cachedir/$title/bodies
  80. set mbox_type = Maildir
  81. set crypt_opportunistic_encrypt = yes
  82. set pgp_self_encrypt = yes
  83. set pgp_default_key = $keyid
  84. bind index,pager gg noop
  85. bind index,pager g noop
  86. bind index,pager M noop
  87. bind index,pager C noop
  88. bind index gg first-entry
  89. macro index o \"<shell-escape>mailsync -V $title<enter>\" \"run mbsync to sync $title\"
  90. unmailboxes *
  91. "
  92. else
  93. mutt_profile="# vim: filetype=neomuttrc
  94. # muttrc file for account $title
  95. set realname = \"$realname\"
  96. set from = \"$fulladdr\"
  97. set sendmail = \"msmtp -a $title\"
  98. alias me $realname <$fulladdr>
  99. set folder = \"imaps://$login@$imap:$iport\"
  100. set imap_user = \"$login\"
  101. set header_cache = $cachedir/$title/headers
  102. set message_cachedir = $cachedir/$title/bodies
  103. set imap_pass = \"\`pass mutt-wizard-$title\`\"
  104. set crypt_opportunistic_encrypt = yes
  105. set pgp_self_encrypt = yes
  106. set pgp_default_key = $keyid
  107. set mbox_type = Maildir
  108. set ssl_starttls = yes
  109. set ssl_force_tls = yes
  110. bind index,pager gg noop
  111. bind index,pager g noop
  112. bind index,pager M noop
  113. bind index,pager C noop
  114. bind index gg first-entry
  115. unmailboxes *
  116. "
  117. fi
  118. printf "DONE.\\n"
  119. }
  120. askinfo() { \
  121. printf "Insert the \033[31memail address\033[0m that you want to autoconfigure for mutt/mbsync\\n\tEmail: \033[36m"
  122. read -r fulladdr
  123. keyid=$( gpg --list-keys --with-colons $fulladdr | awk -F: '/^pub:/ { print $5 }')
  124. printf "\033[0m"
  125. while ! echo "$fulladdr" | grep "$emailre" >/dev/null; do
  126. printf "That is not a valid \033[31memail address\033[0m, please retype the desired email.\\n\\nEmail: \033[36m\t"
  127. read -r fulladdr
  128. printf "\033[0m"
  129. done
  130. domain="$(echo "$fulladdr" | sed "s/.*@//")"
  131. search_query=$domain
  132. case "$domain" in
  133. protonmail.com|protonmail.ch|pm.me)
  134. search_query='protonmail.com' && break;;
  135. *)
  136. while : ; do
  137. printf "\nIs your email hosted with Protonmail? [yes/no] "
  138. read -r is_protonmail
  139. case $is_protonmail in
  140. [Yy][Ee][Ss]) search_query='protonmail.com' && break;;
  141. [Nn][Oo]) break;;
  142. *) printf 'Please answer Yes or No'
  143. esac; done;
  144. esac
  145. printf "\\nSearching for \033[32m%s\033[0m in \033[34m\`domains.csv\`\033[0m..." "$domain"
  146. serverinfo="$(grep "^$search_query" "$muttshare/domains.csv" 2>/dev/null)"
  147. if [ -z "$serverinfo" ]; then
  148. printf "Your email domain is not in mutt-wizard's database yet.\\nmutt-wizard will still autoconfigure everything, but you will have to manually type in your service's IMAP and SMTP server information.\\nYou can usually quickly find this by internet searching for it.\\n"
  149. printf "Insert the IMAP server for your email provider (excluding the port number)\\n\033[36m\t"
  150. read -r imap
  151. printf "\033[0mWhat is your server's IMAP port number? (Usually something like 993)\\n\033[36m\t"
  152. read -r iport
  153. printf "\033[0mInsert the SMTP server for your email provider (excluding the port number)\\n\033[36m\t"
  154. read -r smtp
  155. printf "\033[0mWhat is your server's SMTP port number? (Usually 587 or 465)\\n\033[36m\t"
  156. read -r sport
  157. printf "\033[0m\\nGreat! If you want to be helpful, copy the line below and you can add it to the \`domains.csv\` file on Github.\\nThis will make things easier for others who use your email provider.\\n\\n%s,%s,%s,%s,%s\\n\\nAlthough be sure to test to see if these settings work first! ;-)\\n" "$domain" "$imap" "$iport" "$smtp" "$sport"
  158. else
  159. IFS=, read -r service imap iport smtp sport <<EOF
  160. $serverinfo
  161. EOF
  162. printf "\\n\033[3;33mCongrats!\033[0m Server info has automatically been found, so you won't have to look anything up!\\n\t\033[1mIMAP server\033[0m: %s\\n\t\033[1mIMAP port\033[0m: %s\\n\t\033[1mSMTP server\033[0m: %s\\n\t\033[1mSMTP port\033[0m: %s\\nThis data will be used by the wizard.\\n" "$imap" "$iport" "$smtp" "$sport"
  163. case "$service" in
  164. gmail.com) printf "\033[31mREMEMBER: Gmail users must enable \"less secure\" (third-party) applications first for the sync to work:\\nhttps://support.google.com/accounts/answer/6010255\\n\033[0m" ;;
  165. protonmail.ch|protonmail.com|pm.me) printf "\033[31mREMEMBER: Protonmail users must install and configure Protonmail Bridge first for the sync to work:\\nhttps://protonmail.com/bridge/\\n\033[0m" && ssltype="None" ;;
  166. esac
  167. [ "$sport" = 465 ] && starttlsoff="tls_starttls off"
  168. fi
  169. printf "Enter the \033[35mfull name\033[0m you want to be identified by on this account.\\n\tReal name: "
  170. read -r realname
  171. printf "Enter a short, \033[36mone-word identifier\033[0m for this email account that will distinguish them from any other accounts you add.\\n\tAccount name: "
  172. read -r title
  173. while ! echo "$title" | grep "$namere" >/dev/null || ls "$accdir"/[0-9]"-$title.muttrc" >/dev/null 2>&1; do
  174. printf "\033[31mTry again\033[0m. Pick a nickname that is one word only including lowercase letters and _ or - and that you have \033[1mnot\033[0m used before.\\n\tAccount name: \033[36m\t"
  175. read -r title
  176. printf "\033[0m"
  177. done
  178. printf "If your account has a special username different from your address, insert it now. Otherwise leave this prompt totally blank.\\n\033[34mMost accounts will not have a separate login, so you should probably leave this blank.\033[0m\\n\tLogin(?): \033[36m"
  179. read -r login
  180. printf "\033[0m"
  181. [ -z "$login" ] && login="$fulladdr"
  182. [ "$accounttype" = "offline" ] && printf "If you want to limit the number of messages kept offline to a number, enter that number below. If you do not want to limit your mail and would like \`mbsync\` to sync all mail, press enter without typing a number.\\n\t" && read -r maxmes
  183. echo "$maxmes" | grep "[1-9]" >/dev/null || maxmes="0"
  184. getpass
  185. getprofiles
  186. mkdir -p "$muttdir" "$accdir" "$cachedir/$title/bodies" "$HOME/.config/msmtp"
  187. getaccounts
  188. for x in $(seq 1 9); do echo "$accounts" | grep "$x" >/dev/null 2>&1 || { export idnum="$x"; break ;}; done
  189. [ ! -f "$msmtprc" ] && echo "$msmtp_header" > "$msmtprc"
  190. echo "$msmtp_profile" >> "$msmtprc"
  191. command -V apt-get >/dev/null 2>&1 && ln -s "$msmtprc" "$HOME/.msmtprc" 2>/dev/null
  192. case "$service" in
  193. protonmail.ch|protonmail.com|pm.me) protonfinger || return 1 ;;
  194. esac
  195. echo "$mutt_profile" > "$accdir/$idnum-$title.muttrc"
  196. echo "$mbsync_profile" >> "$mbsyncrc"
  197. notmuchauto
  198. [ ! -f "$muttrc" ] && echo "# vim: filetype=neomuttrc" > "$muttrc" && echo "muttrc created."
  199. ! grep "^source.*mutt-wizard.muttrc" "$muttrc" >/dev/null && echo "source $mwconfig # mw-autogenerated" >> "$muttrc"
  200. ! grep "^source.*.muttrc" "$muttrc" | grep -v "$mwconfig" >/dev/null && echo "source $accdir/$idnum-$title.muttrc # mw-autogenerated" >> "$muttrc"
  201. echo "macro index,pager i$idnum '<sync-mailbox><enter-command>source $accdir/$idnum-$title.muttrc<enter><change-folder>!<enter>;<check-stats>' \"switch to $fulladdr\" # mw-autogenerated" >> "$muttrc"
  202. }
  203. protonfinger() { printf "Getting Protonmail bridge fingerprint...\\n"
  204. fingerprint="$(msmtp --serverinfo --host=127.0.0.1 --port=1025 --tls --tls-certcheck=off | grep SHA256: | sed 's/^.*: //')"
  205. sed -ibu "s/account $title/&\ntls_trust_file\ntls_fingerprint $fingerprint/" "$msmtprc" ; rm -f "$msmtprc"bu
  206. }
  207. getpass() { while : ; do pass rm -f "mutt-wizard-$title" >/dev/null 2>&1
  208. pass insert "mutt-wizard-$title" && break; done ;}
  209. formatShortcut() { \
  210. while read -r data; do { echo "macro index,pager g$1 \"<change-folder>$data<enter>\" \"go to $2\" # mw-autogenerated"
  211. echo "macro index,pager M$1 \";<save-message>$data<enter>\" \"move mail to $2\" # mw-autogenerated"
  212. echo "macro index,pager C$1 \";<copy-message>$data<enter>\" \"copy mail to $2\" # mw-autogenerated"; } >> "$accdir/$idnum-$title.muttrc"
  213. done ;}
  214. tryconnect() { mkdir -p "$maildir/$title"
  215. if mailboxes="$(mbsync -l "$title" | sed 's/\//./')" >/dev/null 2>&1 && [ -n "$mailboxes" ]; then
  216. [ "$accounttype" = "online" ] && sed -ibu "/IMAPStore $title-remote$/,/# End profile/d" "$mbsyncrc" ; rm -f "$mbsyncrc"bu
  217. printf "\033[32mMailboxes detected.\033[0m\\n"
  218. echo "$mailboxes" | xargs -I {} mkdir -p "$maildir/$title/{}"
  219. return 0
  220. else
  221. printf "\033[31m\033[31mLog-on not successful.\033[0m\\nIt seems that either you inputted the wrong password or server settings, or there are other requirements for your account out of the control of mutt-wizard.\\n"
  222. return 1
  223. fi ;}
  224. finalize() { \
  225. boxes="$(find "$maildir/$title/" -mindepth 1 -type d | sed "s/\ /\\\ /g;s/^.*\//=/;/=\(cur\|new\|tmp\)$/d")"
  226. [ -z "$boxes" ] && printf "\033[31mNo local mailboxes have been detected for %s.\033[0m\\nThis means that mbsync has not been successfully run.\\nRun mbsync, and if it has an error, be sure to check your password and server settings manually if needbe.\\n" "$title" && return
  227. printf "Setting default mailboxes for your Inbox, Sent, Drafts and Trash in mutt...\\n"
  228. spoolfile=$(echo "$boxes" | grep -i -m 1 inbox | sed 's/=/+/g')
  229. record=$(echo "$boxes" | grep -i -m 1 sent | sed 's/=/+/g')
  230. postponed=$(echo "$boxes" | grep -i -m 1 draft | sed 's/=/+/g')
  231. trash=$(echo "$boxes" | grep -i -m 1 trash | sed 's/=/+/g')
  232. sed -ibu "/^mailboxes\|^set record\|^set postponed\|^set trash\|^set spoolfile/d" "$accdir/$idnum-$title.muttrc" ; rm -f "$accdir/$idnum-$title.muttrcbu"
  233. { echo "set spoolfile = \"$spoolfile\""; echo "set record = \"$record\""; echo "set postponed = \"$postponed\""; echo "set trash = \"$trash\""; } >> "$accdir/$idnum-$title.muttrc"
  234. echo "mailboxes $(echo "$boxes" | sed -e "s/^\|$/\"/g" | tr "\n" " ")" >> "$accdir/$idnum-$title.muttrc"
  235. printf "Setting up your keyboard shortcuts for jumping between mailboxes...\\n"
  236. sed -ibu "/# mw-autogenerated/d" "$accdir/$idnum-$title.muttrc" ; rm -f "$accdir/$idnum-$title.muttrcbu"
  237. echo "$boxes" | grep -i inbox | head -n 1 | formatShortcut i inbox
  238. echo "$boxes" | grep -i sent | head -n 1 | formatShortcut s sent
  239. echo "$boxes" | grep -i draft | head -n 1 | formatShortcut d drafts
  240. echo "$boxes" | grep -i trash | head -n 1 | formatShortcut t trash
  241. echo "$boxes" | grep -i spam | head -n 1 | formatShortcut S spam
  242. echo "$boxes" | grep -i junk | head -n 1 | formatShortcut j junk
  243. echo "$boxes" | grep -i archive | head -n 1 | formatShortcut a archive
  244. [ "$accounttype" = "offline" ] && printf "All done.\\n\033[33mYou should now be able to run \`\033[32mmbsync %s\033[33m\` to begin to download your mail.\033[0m\\n" "$title"
  245. command -V urlview >/dev/null 2>&1 && [ ! -f "$HOME/.urlview" ] && echo "COMMAND \$BROWSER" > "$HOME/.urlview"
  246. return 0
  247. }
  248. confirm() { printf "Do you want to %s? [yes/N]\\n\t" "$@" && read -r input && ! echo "$input" | grep -i "^yes$" >/dev/null && printf "That doesn't seem like a yes to me.\\n\\n" && return 1
  249. printf "Are you really, really sure you want to %s?\\n\t" "$@" && read -r input && ! echo "$input" | grep -i "^yes$" >/dev/null && printf "That doesn't seem like a yes to me.\\n\\n" && return 1
  250. return 0 ;}
  251. pick() { printf "Select an accounts to %s:\\n" "$1"
  252. list
  253. read -r input
  254. [ -z "$input" ] && return 1
  255. title="$(echo "$accounts" | grep "$input" | awk '{print $2}')"
  256. [ -z "$title" ] && printf "Invalid response." && return 1
  257. return 0 ;}
  258. delete() { sed -ibu "/IMAPStore $title-remote$/,/# End profile/d" "$mbsyncrc" ; rm -rf "$mbsyncrc"bu
  259. rm -rf "${cachedir:?}/${title:?}" "$accdir/"[1-9]"-$title.muttrc"
  260. sed -ibu "/[0-9]-$title.muttrc/d" "$muttrc" ; rm -f "$muttrc"bu
  261. sed -ibu "/account $title/,/^\(\s*$\|account\)/d" "$msmtprc"; rm -f "$msmtprc"bu
  262. }
  263. choosecron() { ! pgrep cron >/dev/null && echo "No cron manager running. Install/enable one and then select this option again." && return 1
  264. if crontab -l | grep mailsync >/dev/null; then
  265. echo "Active mail sync cronjob detected. Do you want to remove it?"
  266. printf "\033[36m\t"
  267. read -r rmyn
  268. printf "\033[0m"
  269. echo "$rmyn" | grep -i "^y\(es\)*$" >/dev/null && crontab -l | sed '/mailsync/d' | crontab - >/dev/null && echo "Mail sync turned off."
  270. else
  271. echo "How many minutes between each mail sync?"
  272. printf "\033[36m\t"
  273. read -r minnum
  274. printf "\033[0m"
  275. while ! echo "$minnum" | grep "^[0-9]\+$" >/dev/null; do
  276. printf "That doesn't look like a number. How many minutes between each mail sync?\\n\033[36m\t"
  277. read -r minnum
  278. printf "\033[0m"
  279. done
  280. (crontab -l; echo "*/$minnum * * * * $(type mailsync | cut -d' ' -f3)") | crontab - &&
  281. echo "Cronjob added. Mail will sync every $minnum minutes. Be sure you have your cron manager running."
  282. fi ;}
  283. asktype() { while : ; do
  284. printf "Do you want to keep your mail for this account offline with mbsync? [yes/no]\\n\t"
  285. read -r offnot
  286. case "$offnot" in
  287. [Yy][Ee][Ss]) accounttype="offline" && break ;;
  288. [Nn][Oo]) accounttype="online" && break ;;
  289. *) echo "Write out either yes or no completely. Try again or press ctrl-c to quit." ;;
  290. esac; done ;}
  291. purge() { confirm "delete all account data" || exit
  292. rm -rf "$mbsyncrc" "$accdir" "$HOME/.config/msmtp" "$cachedir"
  293. crontab -l | sed '/mailsync/d' | crontab - >/dev/null
  294. echo "All configs and account settings have been purged."
  295. sed -ibu "/\# mw-autogenerated/d" "$muttrc" ; rm -f "$muttrc"bu
  296. }
  297. notmuchauto() { \
  298. [ -z "$NOTMUCH_CONFIG" ] && NOTMUCH_CONFIG="$HOME/.notmuch-config"
  299. [ -f "$NOTMUCH_CONFIG" ] && return 0
  300. nmbasic="[database]
  301. path=$maildir
  302. [user]
  303. name=$realname
  304. primary_email=$fulladdr
  305. [new]
  306. tags=unread;inbox;
  307. ignore=.mbsyncstate;.uidvalidity
  308. [search]
  309. exclude_tags=deleted;spam;
  310. [maildir]
  311. synchronize_flags=true
  312. [crypto]
  313. gpg_path=$GPG"
  314. echo "$nmbasic" > "$NOTMUCH_CONFIG" ;}
  315. trap 'echo -e "\033[0m\n"; exit' STOP INT ABRT KILL
  316. case "$1" in
  317. ls) list ;;
  318. add) asktype && askinfo && tryconnect && finalize || delete ;;
  319. pass) pick "change the password of" && getpass ;;
  320. delete) pick delete && confirm "delete the \`$title\` profile" && delete ;;
  321. purge) purge ;;
  322. cron) choosecron ;;
  323. *) cat << EOF
  324. mw: mutt-wizard, auto-configure email accounts for mutt
  325. including downloadable mail with \`isync\`.
  326. Allowed options:
  327. add Add and autoconfigure an email address (9 max.)
  328. ls List configured accounts
  329. delete Pick an account to delete
  330. purge Delete all accounts and settings
  331. cron Enable or disable an autosync via cronjob
  332. all else Print this message
  333. NOTE: Once at least one account is added, you can run
  334. \`mbsync -a\` to begin downloading mail.
  335. EOF
  336. esac